Index: pjproject/trunk/pjmedia/build/Makefile
===================================================================
--- pjproject/trunk/pjmedia/build/Makefile	(revision 410)
+++ pjproject/trunk/pjmedia/build/Makefile	(revision 411)
@@ -65,9 +65,10 @@
 export PJMEDIA_SRCDIR = ../src/pjmedia
 export PJMEDIA_OBJS += $(OS_OBJS) $(M_OBJS) $(CC_OBJS) $(HOST_OBJS) \
-			codec.o conference.o endpoint.o errno.o file_player.o \
-			file_writer.o \
-			g711.o jbuf.o null_port.o port.o resample.o resample_port.o \
-			rtcp.o rtp.o sdp.o sdp_cmp.o sdp_neg.o session.o silencedet.o \
-			sound_port.o stream.o wave.o $(SOUND_OBJS) $(NULLSOUND_OBJS)
+			clock_thread.o codec.o conference.o endpoint.o errno.o \
+			wav_player.o wav_writer.o g711.o jbuf.o \
+			master_port.o null_port.o port.o resample.o \
+			resample_port.o rtcp.o rtp.o sdp.o sdp_cmp.o sdp_neg.o \
+			session.o silencedet.o sound_port.o stream.o wave.o \
+			$(SOUND_OBJS) $(NULLSOUND_OBJS)
 
 export PJMEDIA_CFLAGS += $(_CFLAGS)
@@ -88,13 +89,16 @@
 SPEEX_OBJS :=	speex_codec.o \
 		speex/bits.o speex/cb_search.o speex/exc_10_16_table.o  \
-		speex/exc_10_32_table.o speex/exc_20_32_table.o speex/exc_5_256_table.o \
-		speex/exc_5_64_table.o speex/exc_8_128_table.o speex/filters.o \
-		speex/gain_table.o speex/gain_table_lbr.o speex/hexc_10_32_table.o \
-		speex/hexc_table.o speex/high_lsp_tables.o speex/lpc_spx.o \
-		speex/lsp.o speex/lsp_tables_nb.o speex/ltp.o speex/math_approx.o \
-		speex/misc.o speex/modes.o speex/nb_celp.o speex/preprocess_spx.o \
-		speex/quant_lsp.o speex/sb_celp.o speex/smallft.o speex/speex.o \
-		speex/speex_callbacks.o speex/speex_header.o speex/stereo.o \
-		speex/vbr.o speex/vq.o
+		speex/exc_10_32_table.o speex/exc_20_32_table.o \
+		speex/exc_5_256_table.o speex/exc_5_64_table.o \
+		speex/exc_8_128_table.o speex/filters.o \
+		speex/gain_table.o speex/gain_table_lbr.o \
+		speex/hexc_10_32_table.o speex/hexc_table.o \
+		speex/high_lsp_tables.o speex/lpc_spx.o \
+		speex/lsp.o speex/lsp_tables_nb.o speex/ltp.o \
+		speex/math_approx.o speex/misc.o speex/modes.o \
+		speex/nb_celp.o speex/preprocess_spx.o \
+		speex/quant_lsp.o speex/sb_celp.o speex/smallft.o \
+		speex/speex.o speex/speex_callbacks.o speex/speex_header.o \
+		speex/stereo.o speex/vbr.o speex/vq.o
 SPEEX_CFLAGS := -DHAVE_CONFIG=1 -I../src/pjmedia-codec
 
Index: pjproject/trunk/pjmedia/build/pjmedia.dsp
===================================================================
--- pjproject/trunk/pjmedia/build/pjmedia.dsp	(revision 410)
+++ pjproject/trunk/pjmedia/build/pjmedia.dsp	(revision 411)
@@ -66,5 +66,5 @@
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
-# ADD CPP /nologo /MTd /W4 /Gm /GX /ZI /Od /I "../include" /I "../../pjlib/include" /I "../../pjlib-util/include" /I "../src/pjmedia/portaudio" /D "_DEBUG" /D "PA_NO_ASIO" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /FD /GZ /c
+# ADD CPP /nologo /MTd /W4 /Gm /GX /ZI /Od /I "../include" /I "../../pjlib/include" /I "../../pjlib-util/include" /I "../src/pjmedia/portaudio" /D "_DEBUG" /D "PA_NO_ASIO" /D "PA_NO_WMME" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /FD /GZ /c
 # SUBTRACT CPP /YX
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
@@ -112,12 +112,4 @@
 # Begin Source File
 
-SOURCE=..\src\pjmedia\file_player.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjmedia\file_writer.c
-# End Source File
-# Begin Source File
-
 SOURCE=..\src\pjmedia\g711.c
 # End Source File
@@ -189,4 +181,12 @@
 
 SOURCE=..\src\pjmedia\stream.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjmedia\wav_player.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjmedia\wav_writer.c
 # End Source File
 # Begin Source File
@@ -228,8 +228,4 @@
 # Begin Source File
 
-SOURCE=..\include\pjmedia\file_port.h
-# End Source File
-# Begin Source File
-
 SOURCE=..\include\pjmedia\g711.h
 # End Source File
@@ -297,4 +293,8 @@
 
 SOURCE=..\include\pjmedia\types.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjmedia\wav_port.h
 # End Source File
 # Begin Source File
Index: pjproject/trunk/pjmedia/build/pjmedia_codec.dsp
===================================================================
--- pjproject/trunk/pjmedia/build/pjmedia_codec.dsp	(revision 410)
+++ pjproject/trunk/pjmedia/build/pjmedia_codec.dsp	(revision 411)
@@ -92,4 +92,8 @@
 # Begin Source File
 
+SOURCE="..\src\pjmedia-codec\l16.c"
+# End Source File
+# Begin Source File
+
 SOURCE="..\src\pjmedia-codec\speex_codec.c"
 # End Source File
@@ -105,4 +109,8 @@
 
 SOURCE="..\include\pjmedia-codec\gsm.h"
+# End Source File
+# Begin Source File
+
+SOURCE="..\include\pjmedia-codec\l16.h"
 # End Source File
 # Begin Source File
Index: pjproject/trunk/pjmedia/include/pjmedia-codec.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec.h	(revision 410)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec.h	(revision 411)
@@ -20,4 +20,5 @@
 #define __PJMEDIA_CODEC_PJMEDIA_CODEC_H__
 
+#include <pjmedia-codec/l16.h>
 #include <pjmedia-codec/gsm.h>
 #include <pjmedia-codec/speex.h>
Index: pjproject/trunk/pjmedia/include/pjmedia-codec/config.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/config.h	(revision 410)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/config.h	(revision 411)
@@ -24,4 +24,12 @@
 
 /**
+ * Unless specified otherwise, L16 codec is included by default.
+ */
+#ifndef PJMEDIA_HAS_L16_CODEC
+#   define PJMEDIA_HAS_L16_CODEC    1
+#endif
+
+
+/**
  * Unless specified otherwise, GSM codec is included by default.
  */
Index: pjproject/trunk/pjmedia/include/pjmedia-codec/l16.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/l16.h	(revision 411)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/l16.h	(revision 411)
@@ -0,0 +1,53 @@
+/* $Id$ */
+/* 
+ * Copyright (C)2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJMEDIA_CODEC_L16_H__
+#define __PJMEDIA_CODEC_L16_H__
+
+#include <pjmedia-codec/types.h>
+
+
+PJ_BEGIN_DECL
+
+
+/**
+ * Initialize and register L16 codec factory to pjmedia endpoint.
+ *
+ * @param endpt	    The pjmedia endpoint.
+ * @param options   Must be zero for now.
+ *
+ * @return	    PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pjmedia_codec_l16_init( pjmedia_endpt *endpt,
+					     unsigned options);
+
+
+
+/**
+ * Unregister L16 codec factory from pjmedia endpoint.
+ *
+ * @return	    PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pjmedia_codec_l16_deinit(void);
+
+
+PJ_END_DECL
+
+
+#endif	/* __PJMEDIA_CODEC_L16_H__ */
+
Index: pjproject/trunk/pjmedia/include/pjmedia-codec/types.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/types.h	(revision 410)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/types.h	(revision 411)
@@ -23,3 +23,34 @@
 
 
+/**
+ * These are the dynamic payload types that are used by codecs in
+ * this library. Also see the header file <pjmedia/codec.h> for list
+ * of static payload types.
+ */
+enum
+{
+    /* Telephone events must have pt=101, or otherwise some code needs
+     * to be updated (this would not affect outgoing pt).
+     */
+    PJMEDIA_RTP_PT_TELEPHONE_EVENTS = 101,	/**< telephone-events	    */
+
+    PJMEDIA_RTP_PT_SPEEX_NB,			/**< Speex narrowband/8KHz  */
+    PJMEDIA_RTP_PT_SPEEX_WB,			/**< Speex wideband/16KHz   */
+    PJMEDIA_RTP_PT_SPEEX_UWB,			/**< Speex 32KHz	    */
+    PJMEDIA_RTP_PT_L16_8KHZ_MONO,		/**< L16 @ 8KHz, mono	    */
+    PJMEDIA_RTP_PT_L16_8KHZ_STEREO,		/**< L16 @ 8KHz, stereo     */
+    PJMEDIA_RTP_PT_L16_11KHZ_MONO,		/**< L16 @ 11KHz, mono	    */
+    PJMEDIA_RTP_PT_L16_11KHZ_STEREO,		/**< L16 @ 11KHz, stereo    */
+    PJMEDIA_RTP_PT_L16_16KHZ_MONO,		/**< L16 @ 16KHz, mono	    */
+    PJMEDIA_RTP_PT_L16_16KHZ_STEREO,		/**< L16 @ 16KHz, stereo    */
+    PJMEDIA_RTP_PT_L16_22KHZ_MONO,		/**< L16 @ 22KHz, mono	    */
+    PJMEDIA_RTP_PT_L16_22KHZ_STEREO,		/**< L16 @ 22KHz, stereo    */
+    PJMEDIA_RTP_PT_L16_32KHZ_MONO,		/**< L16 @ 32KHz, mono	    */
+    PJMEDIA_RTP_PT_L16_32KHZ_STEREO,		/**< L16 @ 32KHz, stereo    */
+    PJMEDIA_RTP_PT_L16_48KHZ_MONO,		/**< L16 @ 48KHz, mono	    */
+    PJMEDIA_RTP_PT_L16_48KHZ_STEREO,		/**< L16 @ 48KHz, stereo    */
+};
+
+
+
 #endif	/* __PJMEDIA_CODEC_TYPES_H__ */
Index: pjproject/trunk/pjmedia/include/pjmedia.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia.h	(revision 410)
+++ pjproject/trunk/pjmedia/include/pjmedia.h	(revision 411)
@@ -31,5 +31,4 @@
 #include <pjmedia/endpoint.h>
 #include <pjmedia/errno.h>
-#include <pjmedia/file_port.h>
 #include <pjmedia/g711.h>
 #include <pjmedia/jbuf.h>
@@ -46,4 +45,5 @@
 #include <pjmedia/sound.h>
 #include <pjmedia/sound_port.h>
+#include <pjmedia/wav_port.h>
 #include <pjmedia/wave.h>
 
Index: pjproject/trunk/pjmedia/include/pjmedia/codec.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/codec.h	(revision 410)
+++ pjproject/trunk/pjmedia/include/pjmedia/codec.h	(revision 411)
@@ -49,4 +49,6 @@
 /** 
  * Standard RTP static payload types, as defined by RFC 3551. 
+ * The header file <pjmedia-codec/types.h> also declares dynamic payload
+ * types that are supported by pjmedia-codec library.
  */
 enum pjmedia_rtp_pt
@@ -92,6 +94,13 @@
     unsigned	    pt;		    /**< Payload type (can be dynamic). */
     pj_str_t	    encoding_name;  /**< Encoding name.			*/
-    unsigned	    sample_rate;    /**< Sampling rate.			*/
-};
+    unsigned	    clock_rate;	    /**< Sampling rate.			*/
+    unsigned	    channel_cnt;    /**< Channel count.			*/
+};
+
+
+/**
+ * @see pjmedia_codec_info
+ */
+typedef struct pjmedia_codec_info pjmedia_codec_info;
 
 
@@ -102,20 +111,32 @@
 struct pjmedia_codec_param
 {
-    pj_uint32_t	sample_rate;	    /**< Sampling rate in Hz		*/
+    unsigned	clock_rate;	    /**< Sampling rate in Hz		*/
+    unsigned	channel_cnt;	    /**< Channel count.			*/
     pj_uint32_t	avg_bps;	    /**< Average bandwidth in bits/sec	*/
 
+    pj_uint16_t	ptime;		    /**< Packet time in miliseconds	*/
     pj_uint8_t	pcm_bits_per_sample;/**< Bits/sample in the PCM side	*/
-    pj_uint16_t	ptime;		    /**< Packet time in miliseconds	*/
 
     unsigned	pt:8;		    /**< Payload type.			*/
-    unsigned    vad_enabled:1;	    /**< Voice Activity Detector.	*/
-    unsigned    cng_enabled:1;	    /**< Comfort Noise Generator.	*/
-    unsigned    lpf_enabled:1;	    /**< Low pass filter		*/
-    unsigned    hpf_enabled:1;	    /**< High pass filter		*/
-    unsigned    penh_enabled:1;	    /**< Perceptual Enhancement		*/
-    unsigned    concl_enabled:1;    /**< Packet loss concealment	*/
-    unsigned    reserved_bit:1;	    /**< Reserved, must be NULL.	*/
-
-};
+    unsigned    vad:1;		    /**< Voice Activity Detector.	*/
+    unsigned    cng:1;		    /**< Comfort Noise Generator.	*/
+    unsigned    lpf:1;		    /**< Low pass filter		*/
+    unsigned    hpf:1;		    /**< High pass filter		*/
+    unsigned    penh:1;		    /**< Perceptual Enhancement		*/
+    unsigned    concl:1;	    /**< Packet loss concealment	*/
+    unsigned    reserved:1;	    /**< Reserved, must be NULL.	*/
+
+};
+
+/**
+ * @see pjmedia_codec_param
+ */
+typedef struct pjmedia_codec_param pjmedia_codec_param;
+
+
+/**
+ * @see pjmedia_codec
+ */
+typedef struct pjmedia_codec pjmedia_codec;
 
 
@@ -126,15 +147,4 @@
 struct pjmedia_codec_op
 {
-    /** 
-     * Get default attributes for this codec. 
-     *
-     * @param codec	The codec instance.
-     * @param attr	Pointer to receive default codec attributes.
-     *
-     * @return		PJ_SUCCESS on success.
-     */
-    pj_status_t (*default_attr)(pjmedia_codec *codec, 
-				pjmedia_codec_param *attr);
-
     /** 
      * Initialize codec using the specified attribute.
@@ -226,4 +236,16 @@
 
 /**
+ * Codec operation.
+ */
+typedef struct pjmedia_codec_op pjmedia_codec_op;
+
+
+/**
+ * @see pjmedia_codec_factory
+ */
+typedef struct pjmedia_codec_factory pjmedia_codec_factory;
+
+
+/**
  * This structure describes a codec instance. 
  */
@@ -234,12 +256,13 @@
 
     /** Codec's private data. */
-    void	*codec_data;
+    void		    *codec_data;
 
     /** Codec factory where this codec was allocated. */
-    pjmedia_codec_factory *factory;
+    pjmedia_codec_factory   *factory;
 
     /** Operations to codec. */
-    pjmedia_codec_op	*op;
-};
+    pjmedia_codec_op	    *op;
+};
+
 
 
@@ -274,6 +297,6 @@
      */
     pj_status_t (*default_attr)(pjmedia_codec_factory *factory, 
-				const pjmedia_codec_info *info,
-				pjmedia_codec_param *attr );
+    				const pjmedia_codec_info *info,
+    				pjmedia_codec_param *attr );
 
     /** 
@@ -323,4 +346,10 @@
 
 /**
+ * @see pjmedia_codec_factory_op
+ */
+typedef struct pjmedia_codec_factory_op pjmedia_codec_factory_op;
+
+
+/**
  * Codec factory describes a module that is able to create codec with specific
  * capabilities. These capabilities can be queried by codec manager to create
@@ -340,4 +369,5 @@
 };
 
+
 /**
  * Declare maximum codecs
@@ -345,23 +375,100 @@
 #define PJMEDIA_CODEC_MGR_MAX_CODECS	    32
 
-/**
- * Codec manager maintains codec factory etc.
+
+/**
+ * Specify these values to set the codec priority, by calling
+ * #pjmedia_codec_mgr_set_codec_priority().
+ */
+enum pjmedia_codec_priority
+{
+    /**
+     * This priority makes the codec the highest in the order.
+     * The last codec specified with this priority will get the
+     * highest place in the order, and will change the priority
+     * of previously highest priority codec to NEXT_HIGHER.
+     */
+    PJMEDIA_CODEC_PRIO_HIGHEST,
+
+    /**
+     * This priority will put the codec as the next codec after
+     * codecs with this same priority.
+     */
+    PJMEDIA_CODEC_PRIO_NEXT_HIGHER,
+
+    /**
+     * This is the initial codec priority when it is registered to
+     * codec manager by codec factory.
+     */
+    PJMEDIA_CODEC_PRIO_NORMAL,
+
+    /**
+     * This priority makes the codec the lowest in the order.
+     * The last codec specified with this priority will be put
+     * in the last place in the order.
+     */
+    PJMEDIA_CODEC_PRIO_LOWEST,
+
+    /**
+     * This priority will prevent the codec from being listed in the
+     * SDP created by media endpoint, thus should prevent the codec
+     * from being used in the sessions. However, the codec will still
+     * be listed by #pjmedia_codec_mgr_enum_codecs() and other codec
+     * query functions.
+     */
+    PJMEDIA_CODEC_PRIO_DISABLED,
+};
+
+
+/**
+ * @see pjmedia_codec_priority
+ */
+typedef enum pjmedia_codec_priority pjmedia_codec_priority;
+
+
+/** Fully qualified codec name  (e.g. "pcmu/8000/1") */
+typedef char pjmedia_codec_id[32];
+
+
+/** 
+ * Codec manager maintains array of these structs for each supported
+ * codec.
+ */
+struct pjmedia_codec_desc
+{
+    pjmedia_codec_info	    info;	/**< Codec info.	    */
+    pjmedia_codec_id	    id;		/**< Fully qualified name   */
+    pjmedia_codec_priority  prio;	/**< Priority.		    */
+    pjmedia_codec_factory  *factory;	/**< The factory.	    */
+};
+
+
+/**
+ * The declaration for codec manager. Application doesn't normally need
+ * to see this declaration, but nevertheless this declaration is needed
+ * by media endpoint to instantiate the codec manager.
  */
 struct pjmedia_codec_mgr
 {
     /** List of codec factories registered to codec manager. */
-    pjmedia_codec_factory   factory_list;
+    pjmedia_codec_factory	factory_list;
 
     /** Number of supported codesc. */
-    unsigned		    codec_cnt;
-
-    /** Array of codec info. */
-    pjmedia_codec_info	    codecs[PJMEDIA_CODEC_MGR_MAX_CODECS];
-};
-
-
-
-/**
- * Initialize codec manager.
+    unsigned			codec_cnt;
+
+    /** Array of codec descriptor. */
+    struct pjmedia_codec_desc	codec_desc[PJMEDIA_CODEC_MGR_MAX_CODECS];
+};
+
+
+/**
+ * @see pjmedia_codec_mgr
+ */
+typedef struct pjmedia_codec_mgr pjmedia_codec_mgr;
+
+
+
+/**
+ * Initialize codec manager. Normally this function is called by pjmedia
+ * endpoint's initialization code.
  *
  * @param mgr	    Codec manager instance.
@@ -373,7 +480,9 @@
 
 /** 
- * Register codec factory to codec manager. 
- *
- * @param mgr	    The codec manager.
+ * Register codec factory to codec manager. This will also register
+ * all supported codecs in the factory to the codec manager.
+ *
+ * @param mgr	    The codec manager instance. Application can get the
+ *		    instance by calling #pjmedia_endpt_get_codec_mgr().
  * @param factory   The codec factory to be registered.
  *
@@ -385,7 +494,10 @@
 
 /**
- * Unregister codec factory from the codec manager.
- *
- * @param mgr	    The codec manager.
+ * Unregister codec factory from the codec manager. This will also
+ * remove all the codecs registered by the codec factory from the
+ * codec manager's list of supported codecs.
+ *
+ * @param mgr	    The codec manager instance. Application can get the
+ *		    instance by calling #pjmedia_endpt_get_codec_mgr().
  * @param factory   The codec factory to be unregistered.
  *
@@ -397,7 +509,9 @@
 
 /**
- * Enumerate all supported codec.
- *
- * @param mgr	    The codec manager.
+ * Enumerate all supported codecs that have been registered to the
+ * codec manager by codec factories.
+ *
+ * @param mgr	    The codec manager instance. Application can get the
+ *		    instance by calling #pjmedia_endpt_get_codec_mgr().
  * @param count	    On input, specifies the number of elements in
  *		    the array. On output, the value will be set to
@@ -406,4 +520,5 @@
  * @param info	    The codec info array, which contents will be 
  *		    initialized upon return.
+ * @param prio	    Optional pointer to receive array of codec priorities.
  *
  * @return	    PJ_SUCCESS on success.
@@ -411,10 +526,15 @@
 PJ_DECL(pj_status_t) pjmedia_codec_mgr_enum_codecs( pjmedia_codec_mgr *mgr, 
 						    unsigned *count, 
-						    pjmedia_codec_info info[]);
-
-/**
- * Get codec info for the specified static payload type.
- *
- * @param mgr	    The codec manager.
+						    pjmedia_codec_info info[],
+						    unsigned *prio);
+
+/**
+ * Get codec info for the specified static payload type. Note that
+ * this can only find codec with static payload types. This function can
+ * be used to find codec info for a payload type inside SDP which doesn't
+ * have the corresponding rtpmap attribute.
+ *
+ * @param mgr	    The codec manager instance. Application can get the
+ *		    instance by calling #pjmedia_endpt_get_codec_mgr().
  * @param pt	    Static payload type/number.
  * @param inf	    Pointer to receive codec info.
@@ -422,12 +542,76 @@
  * @return	    PJ_SUCCESS on success.
  */
-PJ_DECL(pj_status_t) pjmedia_codec_mgr_get_codec_info(pjmedia_codec_mgr *mgr,
-						      unsigned pt,
-						      pjmedia_codec_info *inf);
+PJ_DECL(pj_status_t) 
+pjmedia_codec_mgr_get_codec_info( pjmedia_codec_mgr *mgr,
+				  unsigned pt,
+				  const pjmedia_codec_info **inf);
+
+/**
+ * Convert codec info struct into a unique codec identifier.
+ * A codec identifier looks something like "L16/44100/2".
+ *
+ * @param info	    The codec info
+ * @param id	    Buffer to put the codec info string.
+ * @param max_len   The length of the buffer.
+ *
+ * @return	    The null terminated codec info string, or NULL if
+ *		    the buffer is not long enough.
+ */
+PJ_DECL(char*) pjmedia_codec_info_to_id(const pjmedia_codec_info *info,
+				        char *id, unsigned max_len );
+
+
+/**
+ * Find codecs by the unique codec identifier. This function will find
+ * all codecs that match the codec identifier prefix. For example, if
+ * "L16" is specified, then it will find "L16/8000/1", "L16/16000/1",
+ * and so on, up to the maximum count specified in the argument.
+ *
+ * @param mgr	    The codec manager instance. Application can get the
+ *		    instance by calling #pjmedia_endpt_get_codec_mgr().
+ * @param codec_id  The full codec ID or codec ID prefix. If an empty
+ *		    string is given, it will match all codecs.
+ * @param count	    Maximum number of codecs to find. On return, it
+ *		    contains the actual number of codecs found.
+ * @param p_info    Array of pointer to codec info to be filled. This
+ *		    argument may be NULL, which in this case, only
+ *		    codec count will be returned.
+ * @param prio	    Optional array of codec priorities.
+ *
+ * @return	    PJ_SUCCESS if at least one codec info is found.
+ */
+PJ_DECL(pj_status_t) 
+pjmedia_codec_mgr_find_codecs_by_id( pjmedia_codec_mgr *mgr,
+				     const pj_str_t *codec_id,
+				     unsigned *count,
+				     const pjmedia_codec_info *p_info[],
+				     unsigned prio[]);
+
+
+/**
+ * Set codec priority. The codec priority determines the order of
+ * the codec in the SDP created by the endpoint. If more than one codecs
+ * are found with the same codec_id prefix, then the function sets the
+ * priorities of all those codecs.
+ *
+ * @param mgr	    The codec manager instance. Application can get the
+ *		    instance by calling #pjmedia_endpt_get_codec_mgr().
+ * @param codec_id  The full codec ID or codec ID prefix. If an empty
+ *		    string is given, it will match all codecs.
+ * @param prio	    Priority to be set.
+ *
+ * @return	    PJ_SUCCESS if at least one codec info is found.
+ */
+PJ_DECL(pj_status_t)
+pjmedia_codec_mgr_set_codec_priority(pjmedia_codec_mgr *mgr, 
+				     const pj_str_t *codec_id,
+				     pjmedia_codec_priority prio);
+
 
 /**
  * Get default codec param for the specified codec info.
  *
- * @param mgr	    The codec manager.
+ * @param mgr	    The codec manager instance. Application can get the
+ *		    instance by calling #pjmedia_endpt_get_codec_mgr().
  * @param info	    The codec info, which default parameter's is being
  *		    queried.
@@ -437,7 +621,8 @@
  * @return	    PJ_SUCCESS on success.
  */
-PJ_DECL(pj_status_t) pjmedia_codec_mgr_get_default_param(pjmedia_codec_mgr *mgr,
-							 const pjmedia_codec_info *info,
-							 pjmedia_codec_param *param );
+PJ_DECL(pj_status_t) 
+pjmedia_codec_mgr_get_default_param( pjmedia_codec_mgr *mgr,
+				     const pjmedia_codec_info *info,
+				     pjmedia_codec_param *param );
 
 /**
@@ -446,5 +631,6 @@
  * until it finds factory that is able to create the specified codec.
  *
- * @param mgr	    The codec manager.
+ * @param mgr	    The codec manager instance. Application can get the
+ *		    instance by calling #pjmedia_endpt_get_codec_mgr().
  * @param info	    The information about the codec to be created.
  * @param p_codec   Pointer to receive the codec instance.
@@ -452,7 +638,8 @@
  * @return	    PJ_SUCCESS on success.
  */
-PJ_DECL(pj_status_t) pjmedia_codec_mgr_alloc_codec(pjmedia_codec_mgr *mgr, 
-						   const pjmedia_codec_info *info,
-						   pjmedia_codec **p_codec);
+PJ_DECL(pj_status_t) 
+pjmedia_codec_mgr_alloc_codec( pjmedia_codec_mgr *mgr, 
+			       const pjmedia_codec_info *info,
+			       pjmedia_codec **p_codec);
 
 /**
@@ -460,5 +647,6 @@
  * the instance of the codec back to its factory.
  *
- * @param mgr	    The codec manager.
+ * @param mgr	    The codec manager instance. Application can get the
+ *		    instance by calling #pjmedia_endpt_get_codec_mgr().
  * @param codec	    The codec instance.
  *
@@ -468,4 +656,8 @@
 						     pjmedia_codec *codec);
 
+
+
+
+
 /**
  * @}
Index: pjproject/trunk/pjmedia/include/pjmedia/endpoint.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/endpoint.h	(revision 410)
+++ pjproject/trunk/pjmedia/include/pjmedia/endpoint.h	(revision 411)
@@ -40,4 +40,5 @@
 #include <pjmedia/sound.h>
 #include <pjmedia/codec.h>
+#include <pjmedia/sdp.h>
 
 
Index: pjproject/trunk/pjmedia/include/pjmedia/port.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/port.h	(revision 410)
+++ pjproject/trunk/pjmedia/include/pjmedia/port.h	(revision 411)
@@ -78,5 +78,5 @@
     unsigned	    pt;			/**< Payload type (can be dynamic). */
     pj_str_t	    encoding_name;	/**< Encoding name.		    */
-    unsigned	    sample_rate;	/**< Sampling rate.		    */
+    unsigned	    clock_rate;		/**< Sampling rate.		    */
     unsigned	    channel_count;	/**< Number of channels.	    */
     unsigned	    bits_per_sample;	/**< Bits/sample		    */
@@ -102,4 +102,11 @@
 };
 
+
+/** 
+ * @see pjmedia_frame_type
+ */
+typedef enum pjmedia_frame_type pjmedia_frame_type;
+
+
 /** 
  * This structure describes a media frame. 
@@ -112,4 +119,11 @@
     pj_timestamp	 timestamp; /**< Frame timestamp.	    */
 };
+
+
+/** 
+ * @see pjmedia_frame
+ */
+typedef struct pjmedia_frame pjmedia_frame;
+
 
 /**
Index: pjproject/trunk/pjmedia/include/pjmedia/sdp.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/sdp.h	(revision 410)
+++ pjproject/trunk/pjmedia/include/pjmedia/sdp.h	(revision 411)
@@ -78,4 +78,9 @@
     pj_str_t		value;	    /**< Attribute value.   */
 };
+
+/**
+ * @see pjmedia_sdp_attr
+ */
+typedef struct pjmedia_sdp_attr pjmedia_sdp_attr;
 
 
@@ -203,4 +208,9 @@
 };
 
+/**
+ * @see pjmedia_sdp_rtpmap
+ */
+typedef struct pjmedia_sdp_rtpmap pjmedia_sdp_rtpmap;
+
 
 /**
@@ -262,4 +272,11 @@
     pj_str_t		fmt_param;  /**< Format specific parameter. */
 };
+
+
+/**
+ * @see pjmedia_sdp_fmtp
+ */
+typedef struct pjmedia_sdp_fmtp pjmedia_sdp_fmtp;
+
 
 
@@ -291,4 +308,10 @@
     pj_str_t	addr;		/**< The address.			*/
 };
+
+
+/**
+ * @see pjmedia_sdp_conn
+ */
+typedef struct pjmedia_sdp_conn pjmedia_sdp_conn;
 
 
@@ -336,4 +359,10 @@
 
 
+/**
+ * @see pjmedia_sdp_media
+ */
+typedef struct pjmedia_sdp_media pjmedia_sdp_media;
+
+
 /** 
  * Clone SDP media description. 
@@ -482,4 +511,10 @@
 };
 
+/**
+ * @see pjmedia_sdp_session
+ */
+typedef struct pjmedia_sdp_session pjmedia_sdp_session;
+
+
 
 /**
Index: pjproject/trunk/pjmedia/include/pjmedia/sdp_neg.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/sdp_neg.h	(revision 410)
+++ pjproject/trunk/pjmedia/include/pjmedia/sdp_neg.h	(revision 411)
@@ -234,5 +234,5 @@
  */
 
-#include <pjmedia/types.h>
+#include <pjmedia/sdp.h>
 
 PJ_BEGIN_DECL
@@ -277,4 +277,16 @@
 
 /**
+ * @see pjmedia_sdp_neg_state
+ */
+typedef enum pjmedia_sdp_neg_state pjmedia_sdp_neg_state;
+
+
+/**
+ * Opaque declaration of SDP negotiator.
+ */
+typedef struct pjmedia_sdp_neg pjmedia_sdp_neg;
+
+
+/**
  * Get the state string description of the specified state.
  *
Index: pjproject/trunk/pjmedia/include/pjmedia/types.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/types.h	(revision 410)
+++ pjproject/trunk/pjmedia/include/pjmedia/types.h	(revision 411)
@@ -44,4 +44,10 @@
 };
 
+/**
+ * @see pjmedia_type
+ */
+typedef enum pjmedia_type pjmedia_type;
+
+
 
 /** 
@@ -64,4 +70,10 @@
 };
 
+/**
+ * @see pjmedia_dir
+ */
+typedef enum pjmedia_dir pjmedia_dir;
+
+
 /* Alternate names for media direction: */
 
@@ -81,59 +93,4 @@
 #define PJMEDIA_DIR_CAPTURE_PLAYBACK	PJMEDIA_DIR_ENCODING_DECODING
 
-
-/**
- * Top level media type.
- */
-typedef enum pjmedia_type pjmedia_type;
-
-/**
- * Media direction.
- */
-typedef enum pjmedia_dir pjmedia_dir;
-
-/**
- * Codec info.
- */
-typedef struct pjmedia_codec_info pjmedia_codec_info;
-
-/**
- * Codec initialization parameter.
- */
-typedef struct pjmedia_codec_param pjmedia_codec_param;
-
-/** 
- * Types of media frames. 
- */
-typedef enum pjmedia_frame_type pjmedia_frame_type;
-
-/** 
- * This structure describes a media frame. 
- */
-typedef struct pjmedia_frame pjmedia_frame;
-
-/**
- * Codec instance.
- */
-typedef struct pjmedia_codec pjmedia_codec;
-
-/**
- * Codec factory.
- */
-typedef struct pjmedia_codec_factory pjmedia_codec_factory;
-
-/**
- * Codec operation.
- */
-typedef struct pjmedia_codec_op pjmedia_codec_op;
-
-/**
- * Codec factory operation.
- */
-typedef struct pjmedia_codec_factory_op pjmedia_codec_factory_op;
-
-/**
- * Codec manager.
- */
-typedef struct pjmedia_codec_mgr pjmedia_codec_mgr;
 
 /** 
@@ -188,44 +145,4 @@
 
 /**
- * Forward declaration for SDP attribute (sdp.h)
- */
-typedef struct pjmedia_sdp_attr pjmedia_sdp_attr;
-
-/**
- * Forward declaration for SDP rtpmap attribute (sdp.h)
- */
-typedef struct pjmedia_sdp_rtpmap pjmedia_sdp_rtpmap;
-
-/**
- * Forward declaration for SDP fmtp attribute (sdp.h)
- */
-typedef struct pjmedia_sdp_fmtp pjmedia_sdp_fmtp;
-
-/**
- * Forward declaration for SDP connection info (sdp.h)
- */
-typedef struct pjmedia_sdp_conn pjmedia_sdp_conn;
-
-/**
- * Forward declaration for SDP media line (sdp.h)
- */
-typedef struct pjmedia_sdp_media pjmedia_sdp_media;
-
-/**
- * Forward declaration for SDP session (sdp.h)
- */
-typedef struct pjmedia_sdp_session pjmedia_sdp_session;
-
-/**
- * Forward declaration for SDP negotiator state (sdp_neg.h).
- */
-typedef enum pjmedia_sdp_neg_state pjmedia_sdp_neg_state;
-
-/**
- * Forward declaration for SDP negotiator (sdp_neg.h).
- */
-typedef struct pjmedia_sdp_neg pjmedia_sdp_neg;
-
-/**
  * Types of frame returned from jitter buffer (jbuf.h).
  */
